﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Diagrams.Core;

namespace WPFDiagram
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Rect panArea = new Rect(0, 0, 1700, 1000);

        public MainWindow()
        {
            InitializeComponent();

            DiagramConstants.MinimumZoom = 1;

            var drag = new MyDragging(this.diagram);
            drag.DragAllowedArea = this.backgroundShape.Bounds;
            this.diagram.ServiceLocator.Register<IDraggingService>(drag);

            var pan = new MyPanningTool();
            pan.PanAllowedArea = panArea;
            var toolService = this.diagram.ServiceLocator.GetService<IToolService>() as ToolService;
            toolService.ToolList[4] = pan;
        }

        private void OnViewportChanged(object sender, PropertyEventArgs<Rect> e)
        {
            if (!panArea.Contains(e.NewValue))
            {
                double newX = 0;
                double newY = 0;
                var newR = e.NewValue;
                if (this.panArea.Right < newR.Right)
                {
                    newX = this.panArea.Right - newR.Width;
                }
                else if (this.panArea.Left > newR.Left)
                {
                    newX = this.panArea.Left;
                }

                if (this.panArea.Bottom < newR.Bottom)
                {
                    newY = this.panArea.Bottom - newR.Height;
                }
                else if (this.panArea.Top > newR.Top)
                {
                    newY = this.panArea.Top;
                }

                //// You could test this withouy animations - set the telerik:DiagramAnimations.IsZoomAnimationEnabled in XAML to false and use this:
                //// this.diagram.BringIntoView(new Rect(newX, newY, newR.Width, newR.Height), false);
                this.diagram.BringIntoView(new Rect(newX, newY, newR.Width, newR.Height), true);
            }
        }
    }
}
